Leetcode Series. No 098: Validate Binary Search Tree

Max Tsogt
2 min readFeb 12, 2022

Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.

According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes p and q as the lowest node in T that has both p and q as descendants (where we allow a node to be a descendant of itself).”

Example 1:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 8
Output: 6
Explanation: The LCA of nodes 2 and 8 is 6.

Example 2:

Input: root = [6,2,8,0,4,7,9,null,null,3,5], p = 2, q = 4
Output: 2
Explanation: The LCA of nodes 2 and 4 is 2, since a node can be a descendant of itself according to the LCA definition.

Example 3:

Input: root = [2,1], p = 2, q = 1
Output: 2

As always, follow the comments for each line.

In this solution, the time complexity is at worst O(n) or O(log n) which is the height of the branch or tree. And space complexity is O(1) since we are using one node despite the size of the tree.

From my comments on the code, if you have any questions or comments, feel free to reach out.

--

--